"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DVCVariable = void 0;
const utils_1 = require("./utils");
class DVCVariable {
    constructor(variable) {
        const { key, defaultValue } = variable;
        (0, utils_1.checkParamType)('key', key, 'string');
        (0, utils_1.checkParamDefined)('defaultValue', defaultValue);
        this.key = key.toLowerCase();
        if (variable.value === undefined || variable.value === null) {
            this.isDefaulted = true;
            this.value = defaultValue;
        }
        else {
            this.value = variable.value;
            this.isDefaulted = false;
        }
        this.defaultValue = variable.defaultValue;
        this.evalReason = variable.evalReason;
    }
    onUpdate(callback) {
        (0, utils_1.checkParamType)('callback', callback, 'function');
        this.callback = callback;
        return this;
    }
}
exports.DVCVariable = DVCVariable;
//# sourceMappingURL=Variable.js.map